//
//  QuizViewController.m
//  Quiz
//
//  Created by Socratis Tornaritis on 8/14/13.
//  Copyright (c) 2013 Socratis Tornaritis. All rights reserved.
//

#import "QuizViewController.h"

@interface QuizViewController ()

@end


@implementation QuizViewController

- (id)initWithNibName:(NSString *)nibNameOrNil
               bundle:(NSBundle *)nibBundleOrNil {
   
   self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
   if (self) {
      // Initialize to -1 so the app displays the first question.
      currentQuestionIndex = -1;
      
      // Instantiate the two array objects.
      questions = [[NSMutableArray alloc] init];
      answers = [[NSMutableArray alloc] init];
      
      // Populate the arrays with questions/answers.
      [questions addObject:@"What is 7 + 7?"];
      [answers addObject:@"14"];
      
      [questions addObject:@"What is the capital of Vermont?"];
      [answers addObject:@"Montpelier"];
      
      [questions addObject:@"From what is cognac made?"];
      [answers addObject:@"Grapes"];
   }
   
   return self;
   }

- (IBAction)showQuestion:(id)sender {
   currentQuestionIndex = (currentQuestionIndex + 1) % [questions count];
   
   // Choose the next question.
   NSString *question = [questions objectAtIndex:currentQuestionIndex];
   [[self questionField] setText:question];
   
   // Reset the answer field.
   [[self answerField] setText:@"???"];
}

- (IBAction)showAnswer:(id)sender {
   NSString *answer = [answers objectAtIndex:currentQuestionIndex];
   
   [[self answerField] setText:answer];
}

@end
