//
//  BNRItem.h
//  RandomPossessions
//
//  Created by Socratis Tornaritis on 8/18/13.
//  Copyright (c) 2013 Socratis Tornaritis. All rights reserved.
//

#import <Foundation/Foundation.h>

#pragma mark - "Version 1.0"
/* This version uses ivar and accessor methods directly. */

@interface BNRItem : NSObject {
   /* In version 1.0 we declare the ivars explicitly. */
   NSString *itemName;
   NSString *serialNumber;
   int valueInDollars;
   NSDate *dateCreated;
}

#pragma mark - "Class methods"
+ (id)randomItem;

#pragma mark - "Designated initializer"
/* The designated initializer. */
- (id)initWithItemName:(NSString *)name
        valueInDollars:(int)value
          serialNumber:(NSString *)number;

#pragma mark - "Accessors"
- (NSString *)itemName;
- (void)setItemName:(NSString *)str;

- (NSString *)serialNumber;
- (void)setSerialNumber:(NSString *)str;

- (int)valueInDollars;
- (void)setValueInDollars:(int)i;

- (NSDate *)dateCreated;

@end


#pragma mark - "Version 1.1"
///* This version uses the @property and @synthesize directives. */
//@interface BNRItem : NSObject {
//   NSString *itemName;
//   NSString *serialNumber;
//   int valueInDollars;
//   NSDate *dateCreated;
//}
//
//#pragma mark - "Properties"
//@property (nonatomic, copy) NSString *itemName;
//@property (nonatomic, copy) NSString *serialNumber;
//@property (nonatomic, assign) int valueInDollars;
//@property (nonatomic, strong, readonly) NSDate *dateCreated;
//
//#pragma mark - "Class methods"
//+ (id)randomItem;
//
//#pragma mark - "Designated initializer"
///* The designated initializer. */
//- (id)initWithItemName:(NSString *)name
//        valueInDollars:(int)value
//          serialNumber:(NSString *)number;
//
//@end

#pragma mark - "Version 2.0"
///* This version uses declared prototypes. */
//@interface BNRItem : NSObject
//
//#pragma mark - "Properties"
//@property (nonatomic, copy) NSString *itemName;
//@property (nonatomic, copy) NSString *serialNumber;
//@property (nonatomic, assign) int valueInDollars;
//@property (nonatomic, strong, readonly) NSDate *dateCreated;
//
//#pragma mark - "Class methods"
//+ (id)randomItem;
//
//#pragma mark - "Designated initializer"
///* The designated initializer. */
//- (id)initWithItemName:(NSString *)name
//        valueInDollars:(int)value
//          serialNumber:(NSString *)number;
//
//@end
