//
//  BNRItem.m
//  RandomPossessions
//
//  Created by Socratis Tornaritis on 8/18/13.
//  Copyright (c) 2013 Socratis Tornaritis. All rights reserved.
//

#import "BNRItem.h"

#pragma  mark - "Version 1.0"
@implementation BNRItem

#pragma mark - "Class methods"
+ (id)randomItem {
   NSArray *randomAdjectiveList = [NSArray arrayWithObjects:@"Fluffy",
                                                            @"Rusty",
                                                            @"Shiny",
                                                            nil];
   
   NSArray *randomNounList = [NSArray arrayWithObjects:@"Bear",
                                                       @"Spork",
                                                       @"Mac",
                                                       nil];
   
   NSInteger adjectiveIndex = rand() % [randomAdjectiveList count];
   NSInteger nounIndex = rand() % [randomNounList count];
   
   NSString *randomName = [NSString stringWithFormat:@"%@ %@",
                           [randomAdjectiveList objectAtIndex:adjectiveIndex],
                           [randomNounList objectAtIndex:nounIndex]];
   
   int randomValue = rand() % 100;
   
   NSString *randomSerialNumber = [NSString stringWithFormat:@"%c%c%c%c%c",
                                   '0' + rand() % 10,
                                   'A' + rand() % 26,
                                   '0' + rand() % 10,
                                   'A' + rand() % 26,
                                   '0' + rand() % 10];
   
   BNRItem *newItem = [[self alloc] initWithItemName:randomName
                                      valueInDollars:randomValue
                                        serialNumber:randomSerialNumber];
   return newItem;
}

#pragma mark - "Initializers"
- (id)initWithItemName:(NSString *)name
        valueInDollars:(int)value
          serialNumber:(NSString *)number {
   if (self = [super init]) {
      [self setItemName:name];
      [self setValueInDollars:value];
      [self setSerialNumber:number];
      dateCreated = [[NSDate alloc] init];
   }
   
   return self;
}

- (id)init {
   return [self initWithItemName:@"Item"
                  valueInDollars:0
                    serialNumber:@""];
}

#pragma mark - "Accessors"
- (NSString *)itemName {
   return itemName;
}

- (void)setItemName:(NSString *)str {
   itemName = str;
}

- (NSString *)serialNumber {
   return serialNumber;
}

- (void)setSerialNumber:(NSString *)str {
   serialNumber = str;
}

- (int)valueInDollars {
   return valueInDollars;
}

- (void)setValueInDollars:(int)i {
   valueInDollars = i;
}

- (NSDate *)dateCreated {
   return dateCreated;
}

#pragma mark - "Description"
- (NSString *)description {
   NSString *descriptionString = [[NSString alloc] initWithFormat:@"%@ (%@): Worth $%d, recorded on %@",
                                  itemName,
                                  serialNumber,
                                  valueInDollars,
                                  dateCreated];
   
   return descriptionString;
}

@end

#pragma mark - "Version 1.1"
//@implementation BNRItem
//
//@synthesize itemName;
//@synthesize serialNumber;
//@synthesize valueInDollars;
//@synthesize dateCreated;
//
//#pragma mark - "Class methods"
//+ (id)randomItem {
//   NSArray *randomAdjectiveList = [NSArray arrayWithObjects:@"Fluffy",
//                                   @"Rusty",
//                                   @"Shiny",
//                                   nil];
//   
//   NSArray *randomNounList = [NSArray arrayWithObjects:@"Bear",
//                              @"Spork",
//                              @"Mac",
//                              nil];
//   
//   NSInteger adjectiveIndex = rand() % [randomAdjectiveList count];
//   NSInteger nounIndex = rand() % [randomNounList count];
//   
//   NSString *randomName = [NSString stringWithFormat:@"%@ %@",
//                           [randomAdjectiveList objectAtIndex:adjectiveIndex],
//                           [randomNounList objectAtIndex:nounIndex]];
//   
//   int randomValue = rand() % 100;
//   
//   NSString *randomSerialNumber = [NSString stringWithFormat:@"%c%c%c%c%c",
//                                   '0' + rand() % 10,
//                                   'A' + rand() % 26,
//                                   '0' + rand() % 10,
//                                   'A' + rand() % 26,
//                                   '0' + rand() % 10];
//   
//   BNRItem *newItem = [[self alloc] initWithItemName:randomName
//                                      valueInDollars:randomValue
//                                        serialNumber:randomSerialNumber];
//   return newItem;
//}
//
//#pragma mark - "Initializers"
//- (id)initWithItemName:(NSString *)name
//        valueInDollars:(int)value
//          serialNumber:(NSString *)number {
//   if (self = [super init]) {
//      [self setItemName:name];
//      [self setValueInDollars:value];
//      [self setSerialNumber:number];
//      dateCreated = [[NSDate alloc] init];
//   }
//   
//   return self;
//}
//
//- (id)init {
//   return [self initWithItemName:@"Item"
//                  valueInDollars:0
//                    serialNumber:@""];
//}
//
//#pragma mark - "Description"
//- (NSString *)description {
//   NSString *descriptionString = [[NSString alloc] initWithFormat:@"%@ (%@): Worth $%d, recorded on %@",
//                                  itemName,
//                                  serialNumber,
//                                  valueInDollars,
//                                  dateCreated];
//   
//   return descriptionString;
//}
//
//@end

#pragma mark - "Version 2.0"
//@implementation BNRItem
//
//#pragma mark - "Class methods"
//+ (id)randomItem {
//   NSArray *randomAdjectiveList = [NSArray arrayWithObjects:@"Fluffy",
//                                   @"Rusty",
//                                   @"Shiny",
//                                   nil];
//   
//   NSArray *randomNounList = [NSArray arrayWithObjects:@"Bear",
//                              @"Spork",
//                              @"Mac",
//                              nil];
//   
//   NSInteger adjectiveIndex = rand() % [randomAdjectiveList count];
//   NSInteger nounIndex = rand() % [randomNounList count];
//   
//   NSString *randomName = [NSString stringWithFormat:@"%@ %@",
//                           [randomAdjectiveList objectAtIndex:adjectiveIndex],
//                           [randomNounList objectAtIndex:nounIndex]];
//   
//   int randomValue = rand() % 100;
//   
//   NSString *randomSerialNumber = [NSString stringWithFormat:@"%c%c%c%c%c",
//                                   '0' + rand() % 10,
//                                   'A' + rand() % 26,
//                                   '0' + rand() % 10,
//                                   'A' + rand() % 26,
//                                   '0' + rand() % 10];
//   
//   BNRItem *newItem = [[self alloc] initWithItemName:randomName
//                                      valueInDollars:randomValue
//                                        serialNumber:randomSerialNumber];
//   return newItem;
//}
//
//#pragma mark - "Initializers"
//- (id)initWithItemName:(NSString *)name
//        valueInDollars:(int)value
//          serialNumber:(NSString *)number {
//   if (self = [super init]) {
//      [self setItemName:name];
//      [self setValueInDollars:value];
//      [self setSerialNumber:number];
//      _dateCreated = [[NSDate alloc] init];
//   }
//   
//   return self;
//}
//
//- (id)init {
//   return [self initWithItemName:@"Item"
//                  valueInDollars:0
//                    serialNumber:@""];
//}
//
//#pragma mark - "Description"
//- (NSString *)description {
//   NSString *descriptionString = [[NSString alloc] initWithFormat:@"%@ (%@): Worth $%d, recorded on %@",
//                                  [self itemName],
//                                  [self serialNumber],
//                                  [self valueInDollars],
//                                  [self dateCreated]];
//   
//   return descriptionString;
//}
//
//@end
