//
//  STViewController.h
//  Whereami
//
//  Created by Socratis Tornaritis on 9/4/13.
//  Copyright (c) 2013 Socratis Tornaritis. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>     // Locate where we are
#import <MapKit/MapKit.h>                 // Show where we are
#import "STMapPoint.h"

@interface STViewController : UIViewController <CLLocationManagerDelegate,
                                                MKMapViewDelegate> {
   CLLocationManager *locationManager;
}

// Fields for updating the latitude coordinate.
@property (weak, nonatomic) IBOutlet UITextField *latDegrees;
@property (weak, nonatomic) IBOutlet UITextField *latMinutes;
@property (weak, nonatomic) IBOutlet UITextField *latSeconds;
@property (weak, nonatomic) IBOutlet UILabel *latDirection;

// Fields for updating the longitude coordinate.
@property (weak, nonatomic) IBOutlet UITextField *longDegrees;
@property (weak, nonatomic) IBOutlet UITextField *longMinutes;
@property (weak, nonatomic) IBOutlet UITextField *longSeconds;
@property (weak, nonatomic) IBOutlet UILabel *longDirection;

// Field holding the address of the tagged point.
@property (weak, nonatomic) IBOutlet UITextField *currentAddressField;

// The instance of the STMapPoint.
//@property (strong, nonatomic) STMapPoint* mapPoint;

// Main fields for the Map UI.
@property (weak, nonatomic) IBOutlet UIActivityIndicatorView *activityIndicator;
@property (weak, nonatomic) IBOutlet MKMapView *worldView;


// Methods to format the coords in deg min sec.
- (void)updateLatitude:(CLLocationDegrees)degreesLatitude;
- (void)updateLongitude:(CLLocationDegrees)degreesLongitude;

// Methods to handle the location tagging.
//- (void)findLocation;
//- (void)foundLocation:(CLLocation *)location;
@end
